#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2500eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 2500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight25004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight25004xi = {
                1:'-1004x-1786y-1431z',
                2:'-1010x-90y-2284z',
                3:'-1011x-646y-2192z',
                4:'-1063x-603y-2180z',
                5:'-1064x-2256y-149z',
                6:'-1084x-1509y-1672z',
                7:'-1104x-1743y-1411z',
                8:'-1112x-556y-2168z',
                9:'-1160x-506y-2155z',
                10:'-1172x-1463y-1653z',
                11:'-1182x-2199y-124z',
                12:'-1202x-1694y-1390z',
                13:'-1205x-452y-2143z',
                14:'-1247x-395y-2130z',
                15:'-1258x-1412y-1634z',
                16:'-127x-449y-2455z',
                17:'-1287x-334y-2116z',
                18:'-1296x-2135y-99z',
                19:'-1297x-1640y-1369z',
                20:'-1341x-1355y-1615z',
                21:'-136x-824y-2356z',
                22:'-1390x-1580y-1348z',
                23:'-1406x-2065y-74z',
                24:'-1422x-1294y-1596z',
                25:'-1480x-1514y-1327z',
                26:'-1500x-1228y-1577z',
                27:'-1513x-1989y-49z',
                28:'-1567x-1444y-1306z',
                29:'-1575x-1157y-1557z',
                30:'-159x-465y-2451z',
                31:'-1615x-1907y-24z',
                32:'-1647x-1081y-1538z',
                33:'-1651x-1368y-1285z',
                34:'-167x-1673y-1849z',
                35:'-1713x-1820y0z',
                36:'-1714x-1001y-1518z',
                37:'-1730x-1287y-1263z',
                38:'-1778x-917y-1498z',
                39:'-179x-1919y-1591z',
                40:'-1806x-1202y-1241z',
                41:'-1837x-829y-1478z',
                42:'-184x-2472y-323z',
                43:'-184x-839y-2347z',
                44:'-1877x-1112y-1220z',
                45:'-1891x-737y-1458z',
                46:'-192x-479y-2446z',
                47:'-1941x-642y-1437z',
                48:'-1943x-1018y-1198z',
                49:'-1986x-543y-1417z',
                50:'-2004x-920y-1176z',
                51:'-2025x-441y-1396z',
                52:'-2059x-337y-1375z',
                53:'-2061x-818y-1154z',
                54:'-2088x-230y-1354z',
                55:'-2112x-712y-1131z',
                56:'-2157x-604y-1109z',
                57:'-2196x-493y-1087z',
                58:'-227x-490y-2440z',
                59:'-234x-851y-2338z',
                60:'-24x-367y-2472z',
                61:'-257x-1680y-1832z',
                62:'-264x-499y-2435z',
                63:'-282x-1923y-1571z',
                64:'-286x-859y-2329z',
                65:'-302x-505y-2429z',
                66:'-313x-2462y-298z',
                67:'-339x-865y-2320z',
                68:'-341x-509y-2423z',
                69:'-348x-1682y-1815z',
                70:'-382x-510y-2417z',
                71:'-385x-1921y-1552z',
                72:'-393x-867y-2311z',
                73:'-424x-508y-2410z',
                74:'-440x-1679y-1798z',
                75:'-442x-2445y-274z',
                76:'-449x-866y-2301z',
                77:'-466x-502y-2404z',
                78:'-47x-390y-2468z',
                79:'-489x-1913y-1532z',
                80:'-505x-861y-2291z',
                81:'-509x-494y-2397z',
                82:'-533x-1671y-1780z',
                83:'-54x-2474y-348z',
                84:'-552x-482y-2389z',
                85:'-562x-852y-2281z',
                86:'-570x-2421y-249z',
                87:'-593x-1899y-1512z',
                88:'-596x-467y-2382z',
                89:'-5x-343y-2476z',
                90:'-620x-840y-2271z',
                91:'-626x-1657y-1763z',
                92:'-639x-449y-2374z',
                93:'-677x-824y-2260z',
                94:'-681x-428y-2366z',
                95:'-697x-1880y-1492z',
                96:'-697x-2390y-224z',
                97:'-719x-1638y-1745z',
                98:'-71x-411y-2464z',
                99:'-724x-403y-2358z',
                100:'-735x-804y-2250z',
                101:'-765x-375y-2350z',
                102:'-78x-1661y-1866z',
                103:'-78x-1910y-1610z',
                104:'-792x-780y-2239z',
                105:'-800x-1854y-1472z',
                106:'-805x-344y-2341z',
                107:'-812x-1614y-1727z',
                108:'-821x-2352y-199z',
                109:'-844x-309y-2332z',
                110:'-848x-752y-2227z',
                111:'-881x-271y-2323z',
                112:'-903x-1584y-1709z',
                113:'-903x-1823y-1452z',
                114:'-904x-721y-2216z',
                115:'-917x-230y-2314z',
                116:'-944x-2308y-174z',
                117:'-94x-839y-2458z',
                118:'-950x-187y-2304z',
                119:'-958x-685y-2204z',
                120:'-981x-140y-2294z',
                121:'-98x-431y-2460z',
                122:'-994x-1549y-1690z'}

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2500eight4xi" usage = "target function for charge2500eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2500eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2500EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2500EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2500EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2500EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2500EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight25004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2500EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2500EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2500EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight25004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight25004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2500EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2500EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2500EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2500eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  